/* this file is public domain */
#define _LARGEFILE64_SOURCE

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>

int main(int argc,char *argv[])
{
    int GB=1024*1024*1024;
    int fd;
    off64_t pos;
    
    if(argc<3)
    {
	printf("Makes a large file with hole using lseek64\n");
	printf("%s <filename> <fp size in GB>\n",argv[0]);
	return 3;
    }

    fd = open64(argv[1],O_CREAT|O_TRUNC|O_WRONLY,S_IREAD|S_IWRITE);
    if(fd == -1)
    {
	perror("open64");
	return 1;
    }
    pos=atof(argv[2])*GB;
    if(pos!=lseek64(fd,pos,SEEK_SET))
    {
	perror("lseek64");
	return 1;
    }
    if(write(fd,"!",1)<1)
    {
	perror("write");
	return 1;
    }
    if(close(fd))
    {
	perror("close");
	return 1;
    }
    return 0;
}
